'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var core = require('@vue-storefront/core');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

// eslint-disable-next-line @typescript-eslint/no-unused-vars
function getProduct(context, params, customQuery) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, Promise.resolve({
                    data: [],
                    total: 0
                })];
        });
    });
}

// eslint-disable-next-line @typescript-eslint/no-unused-vars
function getCategory(context, params, customQuery) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, Promise.resolve([
                    {
                        id: 1,
                        name: 'Women',
                        slug: 'women',
                        items: [
                            {
                                id: 4,
                                name: 'Women jackets',
                                slug: 'women-jackets',
                                items: [
                                    {
                                        id: 9,
                                        name: 'Winter jackets',
                                        slug: 'winter-jackets',
                                        items: []
                                    },
                                    {
                                        id: 10,
                                        name: 'Autumn jackets',
                                        slug: 'autmun-jackets',
                                        items: []
                                    }
                                ]
                            },
                            {
                                id: 5,
                                name: 'Skirts',
                                slug: 'skirts',
                                items: []
                            }
                        ]
                    },
                    {
                        id: 2,
                        name: 'Men',
                        slug: 'men',
                        items: [
                            {
                                id: 6,
                                name: 'Men T-shirts',
                                slug: 'men-tshirts',
                                items: []
                            }
                        ]
                    },
                    {
                        id: 3,
                        name: 'Kids',
                        slug: 'kids',
                        items: [
                            {
                                id: 7,
                                name: 'Toys',
                                slug: 'toys',
                                items: [
                                    {
                                        id: 8,
                                        name: 'Toy Cars',
                                        slug: 'toy-cars',
                                        items: []
                                    },
                                    {
                                        id: 8,
                                        name: 'Dolls',
                                        slug: 'dolls',
                                        items: []
                                    }
                                ]
                            }
                        ]
                    }
                ])];
        });
    });
}

/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
var searchProducts = function (context, params) { return __awaiter(void 0, void 0, void 0, function () {
    var response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                console.log('llega a api-client');
                return [4 /*yield*/, context.client.execute({
                        uri: context.client
                            .getRequestBuilder()
                            .productProjectionsSearch.parse({})
                            .build(),
                        method: 'GET'
                    })];
            case 1:
                response = _a.sent();
                console.log('response', response);
                return [2 /*return*/, response.body];
        }
    });
}); };

var createClient = require('@commercetools/sdk-client').createClient;
var createAuthMiddlewareForClientCredentialsFlow = require('@commercetools/sdk-middleware-auth').createAuthMiddlewareForClientCredentialsFlow;
var createHttpMiddleware = require('@commercetools/sdk-middleware-http').createHttpMiddleware;
var createQueueMiddleware = require('@commercetools/sdk-middleware-queue').createQueueMiddleware;
var createRequestBuilder = require('@commercetools/api-request-builder').createRequestBuilder;
var fetch = require('node-fetch');
var defaultSettings = {};
var onCreate = function (settings) {
    var config = {
        commercetools: {
            auth: {
                host: 'https://auth.us-central1.gcp.commercetools.com',
                projectKey: 'vsf-test',
                credentials: {
                    clientId: '1fSSHos3RtVEq_1u6MxluPHU',
                    clientSecret: '46BDvgKQEizlrDfsAxp0gNW2W2aA2PDP'
                },
                fetch: fetch
            },
            middleware: {
                host: 'https://api.us-central1.gcp.commercetools.com',
                fetch: fetch
            }
        },
        concurrency: 10
    };
    var commercetools = config.commercetools, concurrency = config.concurrency;
    var auth = commercetools.auth, middleware = commercetools.middleware;
    var middlewares = [
        createAuthMiddlewareForClientCredentialsFlow(auth),
        createQueueMiddleware({ concurrency: concurrency  }),
        createHttpMiddleware(middleware)
    ];
    var client = createClient({
        middlewares: middlewares
    });
    var execute = function (request) { return __awaiter(void 0, void 0, void 0, function () {
        var err_1, headers, error;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, client.execute(request)];
                case 1: return [2 /*return*/, _a.sent()];
                case 2:
                    err_1 = _a.sent();
                    if (typeof err_1 === 'object') {
                        headers = err_1.headers, error = __rest(err_1, ["headers"]);
                        throw error;
                    }
                    throw err_1;
                case 3: return [2 /*return*/];
            }
        });
    }); };
    var getRequestBuilder = function () {
        return createRequestBuilder({
            projectKey: auth.projectKey,
            customServices: {}
        });
    };
    return {
        config: __assign(__assign({}, defaultSettings), settings),
        client: {
            execute: execute,
            getRequestBuilder: getRequestBuilder
        }
    };
};
var createApiClient = core.apiClientFactory({
    onCreate: onCreate,
    api: {
        getProduct: getProduct,
        getCategory: getCategory,
        searchProducts: searchProducts
    }
}).createApiClient;

exports.createApiClient = createApiClient;
//# sourceMappingURL=index.js.map
